import torch
from data_loading import load_and_preprocess, get_sitk_from_nparray
from predict_patient import predict_patient_3D_net
import imp
from utils import postprocess_prediction

brain_mask = None
brain_extracted = None
device = 0

cf = imp.load_source('cf', config_file)
cf = cf.config()

net, _ = cf.get_network(cf.val_use_train_mode, model_file)
if device == "cpu":
    net = net.cpu()
else:
    net.cuda(device)

data, data_dict = load_and_preprocess(in_image)

seg, _, _, _ = predict_patient_3D_net(net, cf.preprocess(data.transpose(0, 3, 2, 1)[:, :, ::-1, ::-1]), cf.val_do_mirroring, cf.val_num_repeats, cf.val_batch_size,
                             cf.net_input_must_be_divisible_by, cf.val_min_size, device, cf.da_mirror_axes)

seg = seg[:, ::-1, ::-1].transpose(2, 1, 0)
seg = postprocess_prediction(seg)

brain_mask, brain_extracted = get_sitk_from_nparray(seg, in_image, data_dict)
